Fingerprint_Card

Loading...
Searching...
No Matches
ICSharpCode.SharpZipLib.Checksums.Adler32 Class Referencesealed

Computes Adler32 checksum for a stream of data. An Adler32 checksum is not as reliable as a CRC32 checksum, but a lot faster to compute. More...

Inheritance diagram for ICSharpCode.SharpZipLib.Checksums.Adler32:
[legend]
Collaboration diagram for ICSharpCode.SharpZipLib.Checksums.Adler32:
[legend]

## Public Member Functions
| Adler32 ()
| Creates a new instance of the Adler32 class. The checksum starts off with a value of 1.
void | Reset ()
| Resets the Adler32 checksum to the initial value.
void | Update (int value)
| Updates the checksum with a byte value.
void | Update (byte[] buffer)
| Updates the checksum with an array of bytes.
void | Update (byte[] buffer, int offset, int count)
| Updates the checksum with the bytes taken from the array.

## Properties
long | Value`[get]`
| Returns the Adler32 data checksum computed so far.

## Private Attributes
uint | checksum

## Static Private Attributes
const uint | BASE = 65521
| largest prime smaller than 65536

## Detailed Description

Computes Adler32 checksum for a stream of data. An Adler32 checksum is not as reliable as a CRC32 checksum, but a lot faster to compute.

The specification for Adler32 may be found in RFC 1950. ZLIB Compressed Data Format Specification version 3.3)

From that document:

     "ADLER32 (Adler-32 checksum)
      This contains a checksum value of the uncompressed data
      (excluding any dictionary data) computed according to Adler-32
      algorithm. This algorithm is a 32-bit extension and improvement
      of the Fletcher algorithm, used in the ITU-T X.224 / ISO 8073
      standard.

      Adler-32 is composed of two sums accumulated per byte: s1 is
      the sum of all bytes, s2 is the sum of all s1 values. Both sums
      are done modulo 65521. s1 is initialized to 1, s2 to zero.  The
      Adler-32 checksum is stored as s2*65536 + s1 in most-
      significant-byte first (network) order."

"8.2. The Adler-32 algorithm The Adler-32 algorithm is much faster than the CRC32 algorithm yet still provides an extremely low probability of undetected errors. The modulo on unsigned long accumulators can be delayed for 5552 bytes, so the modulo operation time is negligible. If the bytes are a, b, c, the second sum is 3a + 2b + c + 3, and so is position and order sensitive, unlike the first sum, which is just a checksum. That 65521 is prime is important to avoid a possible large class of two-byte errors that leave the check unchanged. (The Fletcher checksum uses 255, which is not prime and which also makes the Fletcher check insensitive to single byte changes 0 - 255.) The sum s1 is initialized to 1 instead of zero to make the length of the sequence part of s2, so that the length does not have to be checked separately. (Any sequence of zeroes has a Fletcher checksum of zero.)"

ICSharpCode.SharpZipLib.Zip.Compression.Streams.InflaterInputStream ICSharpCode.SharpZipLib.Zip.Compression.Streams.DeflaterOutputStream

## Constructor & Destructor Documentation

## ◆ Adler32()

ICSharpCode.SharpZipLib.Checksums.Adler32.Adler32 | ( |  | ) |

Creates a new instance of the Adler32 class. The checksum starts off with a value of 1.

Here is the call graph for this function:

## Member Function Documentation

## ◆ Reset()

void ICSharpCode.SharpZipLib.Checksums.Adler32.Reset | ( |  | ) |

Resets the Adler32 checksum to the initial value.

Implements ICSharpCode.SharpZipLib.Checksums.IChecksum.

Here is the caller graph for this function:

## ◆ Update() [1/3]

void ICSharpCode.SharpZipLib.Checksums.Adler32.Update | ( | byte[] | buffer | ) |

Updates the checksum with an array of bytes.

Parameters

  buffer | The source of the data to update with.

Implements ICSharpCode.SharpZipLib.Checksums.IChecksum.

Here is the call graph for this function:

## ◆ Update() [2/3]

void ICSharpCode.SharpZipLib.Checksums.Adler32.Update | ( | byte[] | buffer,
|  | int | offset,
|  | int | count )

Updates the checksum with the bytes taken from the array.

Parameters

  buffer | an array of bytes
  offset | the start of the data used for this update
  count | the number of bytes to use for this update

Implements ICSharpCode.SharpZipLib.Checksums.IChecksum.

## ◆ Update() [3/3]

void ICSharpCode.SharpZipLib.Checksums.Adler32.Update | ( | int | value | ) |

Updates the checksum with a byte value.

Parameters

  value | The data value to add. The high byte of the int is ignored.

Implements ICSharpCode.SharpZipLib.Checksums.IChecksum.

Here is the caller graph for this function:

## Member Data Documentation

## ◆ BASE

const uint ICSharpCode.SharpZipLib.Checksums.Adler32.BASE = 65521
| static private

largest prime smaller than 65536

## ◆ checksum

uint ICSharpCode.SharpZipLib.Checksums.Adler32.checksum
| private

## Property Documentation

## ◆ Value

long ICSharpCode.SharpZipLib.Checksums.Adler32.Value
| get

Returns the Adler32 data checksum computed so far.

Implements ICSharpCode.SharpZipLib.Checksums.IChecksum.

The documentation for this class was generated from the following file:

- ICSharpCode.SharpZLib/Checksums/Adler32.cs